import { StorageDriver, Metaplex, MetaplexFile, MetaplexPlugin, SolAmount } from '@metaplex-foundation/js-next';
import BN from 'bn.js';
export declare type AmmanMockStorageDriverOptions = {
    uploadRoot?: string;
    costPerByte?: BN | number;
    logInfo?: (...data: any[]) => void;
    logDebug?: (...data: any[]) => void;
    logTrace?: (...data: any[]) => void;
};
export declare class AmmanMockStorageDriver extends StorageDriver {
    readonly storageId: string;
    readonly costPerByte: BN;
    readonly logInfo: (...data: any[]) => void;
    readonly logDebug: (...data: any[]) => void;
    readonly logTrace: (...data: any[]) => void;
    readonly uploadRoot?: string | undefined;
    private cache;
    readonly baseUrl: string;
    readonly storageDir: string;
    constructor(metaplex: Metaplex, storageId: string, costPerByte: BN, logInfo: (...data: any[]) => void, logDebug: (...data: any[]) => void, logTrace: (...data: any[]) => void, uploadRoot?: string | undefined);
    static readonly create: (storageId: string, options?: AmmanMockStorageDriverOptions) => MetaplexPlugin;
    static readonly getStorageUri: (storageId: string) => string;
    getPrice(file: MetaplexFile): Promise<SolAmount>;
    upload(file: MetaplexFile): Promise<string>;
    download(uri: string): Promise<MetaplexFile>;
    downloadJson<T extends object>(uri: string): Promise<T>;
}
